require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_cregfile',
  dscmeta_resource_friendly_name: 'cRegFile',
  dscmeta_resource_name: 'cRegFile',
  dscmeta_resource_implementation: 'MOF',
  dscmeta_module_name: 'cRegFile',
  dscmeta_module_version: '1.2',
  docs: 'The DSC cRegFile resource type.
         Automatically generated from version 1.2',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_key: {
      type: 'String',
      desc: 'Name of the registry key to configure recursively',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_regfilepath: {
      type: 'Optional[String]',
      desc: 'Path of the .reg file representing the desired state of the registry key',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
